/* $Id$ */
package saccubus.worker.classic.profile;

import org.apache.commons.lang.StringUtils;

/**
 *
 * @author yuki
 */
public class Proxy implements saccubus.worker.profile.ProxyProfile {

    private String host;
    private int port;
    public static final Proxy NO_PROXY = new Proxy();

    private Proxy() {
        this.host = null;
        this.port = -1;
    }

    public Proxy(String host, int port) {
        if (StringUtils.isEmpty(host) || port < 0 || port > 65535) {
            throw new IllegalArgumentException("プロキシの設定が不適切です");
        }
        this.host = host;
        this.port = port;
    }

    public boolean use(){
        return this != NO_PROXY;
    }

    public String getHost() {
        return host;
    }

    public int getPort() {
        return port;
    }
}
