package yukihane.inqubus.manager;

import java.io.File;
import saccubus.worker.ConvertProgress;
import saccubus.worker.DownloadProgress;
import saccubus.worker.Worker.WorkerListener;
import saccubus.worker.profile.ConvertProfile;
import saccubus.worker.profile.DownloadProfile;

/**
 *
 * @author yuki
 */
public class Request {

    private static int serialId;
    private final int rowId;
    private final DownloadProfile downloadProfile;
    private final String videoId;
    private final WorkerListener<DownloadProgress> downloadProgressListener;
    private final ConvertProfile convertProfile;
    private final WorkerListener<ConvertProgress> convertProgressListener;

    public Request(DownloadProfile download, String videoId, WorkerListener<DownloadProgress> downListener,
            ConvertProfile convert, WorkerListener<ConvertProgress> convListener) {
        this.rowId = ++serialId;
        this.downloadProfile = download;
        this.videoId = videoId;
        this.downloadProgressListener = downListener;
        this.convertProfile = convert;
        this.convertProgressListener = convListener;
    }

    public ConvertProfile getConvertProfile() {
        return convertProfile;
    }

    public DownloadProfile getDownloadProfile() {
        return downloadProfile;
    }

    public String getVideoId() {
        return videoId;
    }

    Integer getRowId() {
        return rowId;
    }

    WorkerListener<DownloadProgress> getDownloadProgressListener() {
        return downloadProgressListener;
    }

    WorkerListener<ConvertProgress> getConvertProgressListener() {
        return convertProgressListener;
    }
}
