package yukihane.inqubus.model;

import java.util.ArrayList;
import java.util.Collection;
import java.util.List;
import javax.swing.table.AbstractTableModel;

/**
 *
 * @author yuki
 */
public class TargetsTableModel extends AbstractTableModel {
    private static final long serialVersionUID = 1L;

    private final List<Target> targets = new ArrayList<Target>();
    private final String[] columnNames = new String[]{"動画", "コメント", "投コメ", "状態"};
    private final Class<?>[] columnClasses = new Class<?>[]{Location.class, Location.class, Location.class, Status.class};

    @Override
    public int getRowCount() {
        return targets.size();
    }

    @Override
    public int getColumnCount() {
        return columnNames.length;
    }

    @Override
    public String getColumnName(int columnIndex) {
        return columnNames[columnIndex];
    }

    @Override
    public Class<?> getColumnClass(int columnIndex) {
        return columnClasses[columnIndex];
    }

    @Override
    public Object getValueAt(int rowIndex, int columnIndex) {
        Target t = targets.get(rowIndex);
        Object res;
        switch (columnIndex) {
            case 0:
                res = t.getMovie();
                break;
            case 1:
                res = t.getComment();
                break;
            case 2:
                res = t.getOwnerComment();
                break;
            case 3:
                res = t.getStatus();
                break;
            default:
                throw new IllegalArgumentException();
        }
        return res;
    }

    @Override
    public void setValueAt(Object aValue, int rowIndex, int columnIndex) {
        throw new UnsupportedOperationException("Not supported yet.");
    }

    public void addTarget(Collection<Target> t) {
        int before = targets.size();
        targets.addAll(t);
        int after = targets.size();
        if (before < after) {
            fireTableRowsInserted(before, after - 1);
        }
    }

    public void addTarget(Target t) {
        List<Target> list = new ArrayList<Target>(1);
        list.add(t);
        addTarget(list);
    }
}
